# Network API

For details on how to use network, see Using OpenStack Network

## The Network Class

The network high-level interface is available through the `network` member of a `Connection` object. The `network` member will only be added if the service is detected.

### Network Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  dhcp_agent_hosting_networks(agent, **query)

    A generator of networks hosted by a DHCP agent.

    Parameters:

      - agent – Either the agent id of an instance of `Agent`

      - query – kwargs query: Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of networks

  add_dhcp_agent_to_network(agent, network)

    Add a DHCP Agent to a network

    Parameters:

      - agent – Either the agent id of an instance of `Agent`

      - network – Network instance

    Returns:

  remove_dhcp_agent_from_network(agent, network)

    Remove a DHCP Agent from a network

    Parameters:

      - agent – Either the agent id of an instance of `Agent`

      - network – Network instance

    Returns:

  create_network(**attrs)

    Create a new network from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `Network`, comprised of the properties on the Network class.

    Returns:

      The results of network creation

    Return type:

      `Network`

  delete_network(network, ignore_missing=True, if_revision=None)

    Delete a network

    Parameters:

      - network – The value can be either the ID of a network or a `Network` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the network does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent network.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

    Returns:

      `None`

  find_network(name_or_id, ignore_missing=True, **query)

    Find a single network

    Parameters:

      - name_or_id – The name or ID of a network.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `Network` or None

  get_network(network)

    Get a single network

    Parameters:

      network – The value can be the ID of a network or a `Network` instance.

    Returns:

      One `Network`

    Raises:

      `NotFoundException` when no resource can be found.

  networks(**query)

    Return a generator of networks

    Parameters:

      query (kwargs) –

      Optional query parameters to be sent to limit the resources being returned. Available parameters include:

      - `description`: The network description.

      - `ipv4_address_scope_id`: The ID of the IPv4 address scope for the network.

      - `ipv6_address_scope_id`: The ID of the IPv6 address scope for the network.

      - `is_admin_state_up`: Network administrative state

      - `is_port_security_enabled`: The port security status.

      - `is_router_external`: Network is external or not.

      - `is_shared`: Whether the network is shared across projects.

      - `name`: The name of the network.

      - `status`: Network status

      - `project_id`: Owner tenant ID

      - `provider_network_type`: Network physical mechanism

      - `provider_physical_network`: Physical network

      - `provider_segmentation_id`: VLAN ID for VLAN networks or Tunnel ID for GENEVE/GRE/VXLAN networks

    Returns:

      A generator of network objects

    Return type:

      `Network`

  update_network(network, if_revision=None, **attrs)

    Update a network

    Parameters:

      - network – Either the id of a network or an instance of type `Network`.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

      - attrs – The attributes to update on the network represented by `network`.

    Returns:

      The updated network

    Return type:

      `Network`

  find_network_ip_availability(name_or_id, ignore_missing=True, **query)

    Find IP availability of a network

    Parameters:

      - name_or_id – The name or ID of a network.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `NetworkIPAvailability` or None

  get_network_ip_availability(network)

    Get IP availability of a network

    Parameters:

      network – The value can be the ID of a network or a `Network` instance.

    Returns:

      One `NetworkIPAvailability`

    Raises:

      `NotFoundException` when no resource can be found.

  network_ip_availabilities(**query)

    Return a generator of network ip availabilities

    Parameters:

      query (kwargs) –

      Optional query parameters to be sent to limit the resources being returned. Available parameters include:

      - `ip_version`: IP version of the network

      - `network_id`: ID of network to use when listening network IP availability.

      - `network_name`: The name of the network for the particular network IP availability.

      - `project_id`: Owner tenant ID

    Returns:

      A generator of network ip availability objects

    Return type:

      `NetworkIPAvailability`

### Port Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_port(**attrs)

    Create a new port from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `Port`, comprised of the properties on the Port class.

    Returns:

      The results of port creation

    Return type:

      `Port`

  create_ports(data)

    Create ports from the list of attributes

    Parameters:

      data (list) – List of dicts of attributes which will be used to create a `Port`, comprised of the properties on the Port class.

    Returns:

      A generator of port objects

    Return type:

      `Port`

  delete_port(port, ignore_missing=True, if_revision=None)

    Delete a port

    Parameters:

      - port – The value can be either the ID of a port or a `Port` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the port does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent port.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

    Returns:

      `None`

  find_port(name_or_id, ignore_missing=True, **query)

    Find a single port

    Parameters:

      - name_or_id – The name or ID of a port.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `Port` or None

  get_port(port)

    Get a single port

    Parameters:

      port – The value can be the ID of a port or a `Port` instance.

    Returns:

      One `Port`

    Raises:

      `NotFoundException` when no resource can be found.

  ports(**query)

    Return a generator of ports

    Parameters:

      query (kwargs) –

      Optional query parameters to be sent to limit the resources being returned. Available parameters include:

      - `description`: The port description.

      - `device_id`: Port device ID.

      - `device_owner`: Port device owner (e.g. `network:dhcp`).

      - `ip_address`: IP addresses of an allowed address pair.

      - `is_admin_state_up`: The administrative state of the port.

      - `is_port_security_enabled`: The port security status.

      - `mac_address`: Port MAC address.

      - `name`: The port name.

      - `network_id`: ID of network that owns the ports.

      - `project_id`: The ID of the project who owns the network.

      - `status`: The port status. Value is `ACTIVE` or `DOWN`.

      - `subnet_id`: The ID of the subnet.

    Returns:

      A generator of port objects

    Return type:

      `Port`

  update_port(port, if_revision=None, **attrs)

    Update a port

    Parameters:

      - port – Either the id of a port or a `Port` instance.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

      - attrs – The attributes to update on the port represented by `port`.

    Returns:

      The updated port

    Return type:

      `Port`

### Router Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_router(**attrs)

    Create a new router from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `Router`, comprised of the properties on the Router class.

    Returns:

      The results of router creation

    Return type:

      `Router`

  delete_router(router, ignore_missing=True, if_revision=None)

    Delete a router

    Parameters:

      - router – The value can be either the ID of a router or a `Router` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the router does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent router.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

    Returns:

      `None`

  find_router(name_or_id, ignore_missing=True, **query)

    Find a single router

    Parameters:

      - name_or_id – The name or ID of a router.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `Router` or None

  get_router(router)

    Get a single router

    Parameters:

      router – The value can be the ID of a router or a `Router` instance.

    Returns:

      One `Router`

    Raises:

      `NotFoundException` when no resource can be found.

  routers(**query)

    Return a generator of routers

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Valid parameters are:

      - `description`: The description of a router.

      - `flavor_id`: The ID of the flavor.

      - `is_admin_state_up`: Router administrative state is up or not

      - `is_distributed`: The distributed state of a router

      - `is_ha`: The highly-available state of a router

      - `name`: Router name

      - `project_id`: The ID of the project this router is associated with.

      - `status`: The status of the router.

    Returns:

      A generator of router objects

    Return type:

      `Router`

  update_router(router, if_revision=None, **attrs)

    Update a router

    Parameters:

      - router – Either the id of a router or a `Router` instance.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

      - attrs – The attributes to update on the router represented by `router`.

    Returns:

      The updated router

    Return type:

      `Router`

  add_interface_to_router(router, subnet_id=None, port_id=None)

    Add Interface to a router

    Parameters:

      - router – Either the router ID or an instance of `Router`

      - subnet_id – ID of the subnet

      - port_id – ID of the port

    Returns:

      Router with updated interface

    Return type:

      `Router`

  remove_interface_from_router(router, subnet_id=None, port_id=None)

    Remove Interface from a router

    Parameters:

      - router – Either the router ID or an instance of `Router`

      - subnet – ID of the subnet

      - port – ID of the port

    Returns:

      Router with updated interface

    Return type:

      `Router`

  add_extra_routes_to_router(router, body)

    Add extra routes to a router

    Parameters:

      - router – Either the router ID or an instance of `Router`

      - body – The request body as documented in the api-ref.

    Returns:

      Router with updated extra routes

    Return type:

      `Router`

  remove_extra_routes_from_router(router, body)

    Remove extra routes from a router

    Parameters:

      - router – Either the router ID or an instance of `Router`

      - body – The request body as documented in the api-ref.

    Returns:

      Router with updated extra routes

    Return type:

      `Router`

  add_gateway_to_router(router, **body)

    Add Gateway to a router

    Parameters:

      - router – Either the router ID or an instance of `Router`

      - body – Body with the gateway information

    Returns:

      Router with updated interface

    Return type:

      `Router`

  remove_gateway_from_router(router, **body)

    Remove Gateway from a router

    Parameters:

      - router – Either the router ID or an instance of `Router`

      - body – Body with the gateway information

    Returns:

      Router with updated interface

    Return type:

      `Router`

  add_external_gateways(router, body)

    Add router external gateways

    Parameters:

      - router – Either the router ID or an instance of `Router`

      - body – Body containing the external_gateways parameter.

    Returns:

      Router with added gateways

    Return type:

      `Router`

  update_external_gateways(router, body)

    Update router external gateways

    Parameters:

      - router – Either the router ID or an instance of `Router`

      - body – Body containing the external_gateways parameter.

    Returns:

      Router with updated gateways

    Return type:

      `Router`

  remove_external_gateways(router, body)

    Remove router external gateways

    Parameters:

      - router – Either the router ID or an instance of `Router`

      - body – Body containing the external_gateways parameter.

    Returns:

      Router without the removed gateways

    Return type:

      `Router`

  create_conntrack_helper(router, **attrs)

    Create a new L3 conntrack helper from attributes

    Parameters:

      - router – Either the router ID or an instance of `Router`

      - attrs – Keyword arguments which will be used to create a `ConntrackHelper`, comprised of the properties on the ConntrackHelper class.

    Returns:

      The results of conntrack helper creation

    Return type:

      `ConntrackHelper`

  conntrack_helpers(router, **query)

    Return a generator of conntrack helpers

    Parameters:

      - router – Either the router ID or an instance of `Router`

      - query (kwargs) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of conntrack helper objects

    Return type:

      `ConntrackHelper`

  get_conntrack_helper(conntrack_helper, router)

    Get a single L3 conntrack helper

    Parameters:

      - conntrack_helper – The value can be the ID of a L3 conntrack helper or a `ConntrackHelper`, instance.

      - router – The value can be the ID of a Router or a `Router` instance.

    Returns:

      One `ConntrackHelper`

    Raises:

      `NotFoundException` when no resource can be found.

  update_conntrack_helper(conntrack_helper, router, **attrs)

    Update a L3 conntrack_helper

    Parameters:

      - conntrack_helper – The value can be the ID of a L3 conntrack helper or a `ConntrackHelper`, instance.

      - router – The value can be the ID of a Router or a `Router` instance.

      - attrs – The attributes to update on the L3 conntrack helper represented by `conntrack_helper`.

    Returns:

      The updated conntrack helper

    Return type:

      `ConntrackHelper`

  delete_conntrack_helper(conntrack_helper, router, ignore_missing=True)

    Delete a L3 conntrack_helper

    Parameters:

      - conntrack_helper – The value can be the ID of a L3 conntrack helper or a `ConntrackHelper`, instance.

      - router – The value can be the ID of a Router or a `Router` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the floating ip does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent ip.

    Returns:

      `None`

### Floating IP Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_ip(**attrs)

    Create a new floating ip from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `FloatingIP`, comprised of the properties on the FloatingIP class.

    Returns:

      The results of floating ip creation

    Return type:

      `FloatingIP`

  delete_ip(floating_ip, ignore_missing=True, if_revision=None)

    Delete a floating ip

    Parameters:

      - floating_ip – The value can be either the ID of a floating ip or a `FloatingIP` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the floating ip does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent ip.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

    Returns:

      `None`

  find_available_ip()

    Find an available IP

    Returns:

      One `FloatingIP` or None

  find_ip(name_or_id, ignore_missing=True, **query)

    Find a single IP

    Parameters:

      - name_or_id – The name or ID of an IP.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `FloatingIP` or None

  get_ip(floating_ip)

    Get a single floating ip

    Parameters:

      floating_ip – The value can be the ID of a floating ip or a `FloatingIP` instance.

    Returns:

      One `FloatingIP`

    Raises:

      `NotFoundException` when no resource can be found.

  ips(**query)

    Return a generator of ips

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Valid parameters are:

      - `description`: The description of a floating IP.

      - `fixed_ip_address`: The fixed IP address associated with a floating IP address.

      - `floating_ip_address`: The IP address of a floating IP.

      - `floating_network_id`: The ID of the network associated with a floating IP.

      - `port_id`: The ID of the port to which a floating IP is associated.

      - `project_id`: The ID of the project a floating IP is associated with.

      - `router_id`: The ID of an associated router.

      - `status`: The status of a floating IP, which can be `ACTIVE` or `DOWN`.

    Returns:

      A generator of floating IP objects

    Return type:

      `FloatingIP`

  update_ip(floating_ip, if_revision=None, **attrs)

    Update a ip

    Parameters:

      - floating_ip – Either the id of a ip or a `FloatingIP` instance.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

      - attrs – The attributes to update on the ip represented by `value`.

    Returns:

      The updated ip

    Return type:

      `FloatingIP`

### Pool Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_pool(**attrs)

    Create a new pool from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `Pool`, comprised of the properties on the Pool class.

    Returns:

      The results of pool creation

    Return type:

      `Pool`

  delete_pool(pool, ignore_missing=True)

    Delete a pool

    Parameters:

      - pool – The value can be either the ID of a pool or a `Pool` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the pool does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent pool.

    Returns:

      `None`

  find_pool(name_or_id, ignore_missing=True, **query)

    Find a single pool

    Parameters:

      - name_or_id – The name or ID of a pool.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `Pool` or None

  get_pool(pool)

    Get a single pool

    Parameters:

      pool – The value can be the ID of a pool or a `Pool` instance.

    Returns:

      One `Pool`

    Raises:

      `NotFoundException` when no resource can be found.

  pools(**query)

    Return a generator of pools

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Valid parameters are:

      - `description`: The description for the pool.

      - `is_admin_state_up`: The administrative state of the pool.

      - `lb_algorithm`: The load-balancer algorithm used, which is one of `round-robin`, `least-connections` and so on.

      - `name`: The name of the node pool.

      - `project_id`: The ID of the project the pool is associated with.

      - `protocol`: The protocol used by the pool, which is one of `TCP`, `HTTP` or `HTTPS`.

      - `provider`: The name of the provider of the load balancer service.

      - `subnet_id`: The subnet on which the members of the pool are located.

      - `virtual_ip_id`: The ID of the virtual IP used.

    Returns:

      A generator of pool objects

    Return type:

      `Pool`

  update_pool(pool, **attrs)

    Update a pool

    Parameters:

      - pool – Either the id of a pool or a `Pool` instance.

      - attrs – The attributes to update on the pool represented by `pool`.

    Returns:

      The updated pool

    Return type:

      `Pool`

  create_pool_member(pool, **attrs)

    Create a new pool member from attributes

    Parameters:

      - pool – The pool can be either the ID of a pool or a `Pool` instance that the member will be created in.

      - attrs – Keyword arguments which will be used to create a `PoolMember`, comprised of the properties on the PoolMember class.

    Returns:

      The results of pool member creation

    Return type:

      `PoolMember`

  delete_pool_member(pool_member, pool, ignore_missing=True)

    Delete a pool member

    Parameters:

      - pool_member – The member can be either the ID of a pool member or a `PoolMember` instance.

      - pool – The pool can be either the ID of a pool or a `Pool` instance that the member belongs to.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the pool member does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent pool member.

    Returns:

      `None`

  find_pool_member(name_or_id, pool, ignore_missing=True, **query)

    Find a single pool member

    Parameters:

      - name_or_id (str) – The name or ID of a pool member.

      - pool – The pool can be either the ID of a pool or a `Pool` instance that the member belongs to.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `PoolMember` or None

  get_pool_member(pool_member, pool)

    Get a single pool member

    Parameters:

      - pool_member – The member can be the ID of a pool member or a `PoolMember` instance.

      - pool – The pool can be either the ID of a pool or a `Pool` instance that the member belongs to.

    Returns:

      One `PoolMember`

    Raises:

      `NotFoundException` when no resource can be found.

  pool_members(pool, **query)

    Return a generator of pool members

    Parameters:

      - pool – The pool can be either the ID of a pool or a `Pool` instance that the member belongs to.

      - query (dict) –

        Optional query parameters to be sent to limit the resources being returned. Valid parameters are:

        - `address`: The IP address of the pool member.

        - `is_admin_state_up`: The administrative state of the pool member.

        - `name`: Name of the pool member.

        - `project_id`: The ID of the project this pool member is associated with.

        - `protocol_port`: The port on which the application is hosted.

        - `subnet_id`: Subnet ID in which to access this pool member.

        - `weight`: A positive integer value that indicates the relative portion of traffic that this member should receive from the pool.

    Returns:

      A generator of pool member objects

    Return type:

      `PoolMember`

  update_pool_member(pool_member, pool, **attrs)

    Update a pool member

    Parameters:

      - pool_member – Either the ID of a pool member or a `PoolMember` instance.

      - pool – The pool can be either the ID of a pool or a `Pool` instance that the member belongs to.

      - attrs – The attributes to update on the pool member represented by `pool_member`.

    Returns:

      The updated pool member

    Return type:

      `PoolMember`

### Auto Allocated Topology Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  get_auto_allocated_topology(project=None)

    Get the auto-allocated topology of a given tenant

    Parameters:

      project – The value is the ID or name of a project

    Returns:

      The auto-allocated topology

    Return type:

      `AutoAllocatedTopology`

  delete_auto_allocated_topology(project=None, ignore_missing=False)

    Delete auto-allocated topology

    Parameters:

      - project – The value is the ID or name of a project

      - ignore_missing – When set to `False` `NotFoundException` will be raised when the topology does not exist. When set to `True`, no exception will be raised when attempting to delete nonexistant topology

    Returns:

      `None`

  validate_auto_allocated_topology(project=None)

    Validate the resources for auto allocation

    Parameters:

      project – The value is the ID or name of a project

    Returns:

      Whether all resources are correctly configured or not

    Return type:

      `ValidateTopology`

### Default Security Group Rules Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_default_security_group_rule(**attrs)

    Create a new default security group rule from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `DefaultSecurityGroupRule`, comprised of the properties on the DefaultSecurityGroupRule class.

    Returns:

      The results of default security group rule creation

    Return type:

      `DefaultSecurityGroupRule`

  delete_default_security_group_rule(default_security_group_rule, ignore_missing=True)

    Delete a default security group rule

    Parameters:

      - default_security_group_rule – The value can be either the ID of a default security group rule or a `DefaultSecurityGroupRule` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the defaul security group rule does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent default security group rule.

    Returns:

      `None`

  find_default_security_group_rule(name_or_id, ignore_missing=True, **query)

    Find a single default security group rule

    Parameters:

      - name_or_id (str) – The ID of a default security group rule.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `DefaultSecurityGroupRule` or None

  get_default_security_group_rule(default_security_group_rule)

    Get a single default security group rule

    Parameters:

      default_security_group_rule – The value can be the ID of a default security group rule or a `DefaultSecurityGroupRule` instance.

    Returns:

      `DefaultSecurityGroupRule`

    Raises:

      `NotFoundException` when no resource can be found.

  default_security_group_rules(**query)

    Return a generator of default security group rules

    Parameters:

      query (kwargs) –

      Optional query parameters to be sent to limit the resources being returned. Available parameters include:

      - `description`: The default security group rule description

      - `direction`: Default security group rule direction

      - `ether_type`: Must be IPv4 or IPv6, and addresses represented in CIDR must match the ingress or egress rule.

      - `protocol`: Default security group rule protocol

      - `remote_group_id`: ID of a remote security group

    Returns:

      A generator of default security group rule objects

    Return type:

      `DefaultSecurityGroupRule`

### Security Group Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_security_group(**attrs)

    Create a new security group from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `SecurityGroup`, comprised of the properties on the SecurityGroup class.

    Returns:

      The results of security group creation

    Return type:

      `SecurityGroup`

  delete_security_group(security_group, ignore_missing=True, if_revision=None)

    Delete a security group

    Parameters:

      - security_group – The value can be either the ID of a security group or a `SecurityGroup` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the security group does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent security group.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

    Returns:

      `None`

  find_security_group(name_or_id, ignore_missing=True, **query)

    Find a single security group

    Parameters:

      - name_or_id – The name or ID of a security group.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `SecurityGroup` or None

  get_security_group(security_group)

    Get a single security group

    Parameters:

      security_group – The value can be the ID of a security group or a `SecurityGroup` instance.

    Returns:

      One `SecurityGroup`

    Raises:

      `NotFoundException` when no resource can be found.

  security_groups(**query)

    Return a generator of security groups

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Valid parameters are:

      - `description`: Security group description

      - `ìd`: The id of a security group, or list of security group ids

      - `name`: The name of a security group

      - `project_id`: The ID of the project this security group is associated with.

    Returns:

      A generator of security group objects

    Return type:

      `SecurityGroup`

  update_security_group(security_group, if_revision=None, **attrs)

    Update a security group

    Parameters:

      - security_group – Either the id of a security group or a `SecurityGroup` instance.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

      - attrs – The attributes to update on the security group represented by `security_group`.

    Returns:

      The updated security group

    Return type:

      `SecurityGroup`

  create_security_group_rule(**attrs)

    Create a new security group rule from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `SecurityGroupRule`, comprised of the properties on the SecurityGroupRule class.

    Returns:

      The results of security group rule creation

    Return type:

      `SecurityGroupRule`

  create_security_group_rules(data)

    Create new security group rules from the list of attributes

    Parameters:

      data (list) – List of dicts of attributes which will be used to create a `SecurityGroupRule`, comprised of the properties on the SecurityGroupRule class.

    Returns:

      A generator of security group rule objects

    Return type:

      `SecurityGroupRule`

  delete_security_group_rule(security_group_rule, ignore_missing=True, if_revision=None)

    Delete a security group rule

    Parameters:

      - security_group_rule – The value can be either the ID of a security group rule or a `SecurityGroupRule` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the security group rule does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent security group rule.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

    Returns:

      `None`

  find_security_group_rule(name_or_id, ignore_missing=True, **query)

    Find a single security group rule

    Parameters:

      - name_or_id (str) – The ID of a security group rule.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `SecurityGroupRule` or None

  get_security_group_rule(security_group_rule)

    Get a single security group rule

    Parameters:

      security_group_rule – The value can be the ID of a security group rule or a `SecurityGroupRule` instance.

    Returns:

      `SecurityGroupRule`

    Raises:

      `NotFoundException` when no resource can be found.

  security_group_rules(**query)

    Return a generator of security group rules

    Parameters:

      query (kwargs) –

      Optional query parameters to be sent to limit the resources being returned. Available parameters include:

      - `description`: The security group rule description

      - `direction`: Security group rule direction

      - `ether_type`: Must be IPv4 or IPv6, and addresses represented in CIDR must match the ingress or egress rule.

      - `project_id`: The ID of the project this security group rule is associated with.

      - `protocol`: Security group rule protocol

      - `remote_group_id`: ID of a remote security group

      - `security_group_id`: ID of security group that owns the rules

    Returns:

      A generator of security group rule objects

    Return type:

      `SecurityGroupRule`

### Address Group Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_address_group(**attrs)

    Create a new address group from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `AddressGroup`, comprised of the properties on the AddressGroup class.

    Returns:

      The results of address group creation

    Return type:

      `AddressGroup`

  delete_address_group(address_group, ignore_missing=True)

    Delete an address group

    Parameters:

      - address_group – The value can be either the ID of an address group or a `AddressGroup` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the address group does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent address group.

    Returns:

      `None`

  find_address_group(name_or_id, ignore_missing=True, **query)

    Find a single address group

    Parameters:

      - name_or_id – The name or ID of an address group.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `AddressGroup` or None

  get_address_group(address_group)

    Get a single address group

    Parameters:

      address_group – The value can be the ID of an address group or a `AddressGroup` instance.

    Returns:

      One `AddressGroup`

    Raises:

      `NotFoundException` when no resource can be found.

  address_groups(**query)

    Return a generator of address groups

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned.

      - `name`: Address group name

      - `description`: Address group description

      - `project_id`: Owner project ID

    Returns:

      A generator of address group objects

    Return type:

      `AddressGroup`

  update_address_group(address_group, **attrs)

    Update an address group

    Parameters:

      - address_group – Either the ID of an address group or a `AddressGroup` instance.

      - attrs – The attributes to update on the address group represented by `value`.

    Returns:

      The updated address group

    Return type:

      `AddressGroup`

  add_addresses_to_address_group(address_group, addresses)

    Add addresses to a address group

    Parameters:

      - address_group – Either the ID of an address group or a `AddressGroup` instance.

      - addresses (list) – List of address strings.

    Returns:

      AddressGroup with updated addresses

    Return type:

      `AddressGroup`

  remove_addresses_from_address_group(address_group, addresses)

    Remove addresses from a address group

    Parameters:

      - address_group – Either the ID of an address group or a `AddressGroup` instance.

      - addresses (list) – List of address strings.

    Returns:

      AddressGroup with updated addresses

    Return type:

      `AddressGroup`

### Availability Zone Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  availability_zones(**query)

    Return a generator of availability zones

    Parameters:

      query (dict) –

      optional query parameters to be set to limit the returned resources. Valid parameters include:

      - `name`: The name of an availability zone.

      - `resource`: The type of resource for the availability zone.

    Returns:

      A generator of availability zone objects

    Return type:

      `AvailabilityZone`

### Address Scope Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_address_scope(**attrs)

    Create a new address scope from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `AddressScope`, comprised of the properties on the AddressScope class.

    Returns:

      The results of address scope creation

    Return type:

      `AddressScope`

  delete_address_scope(address_scope, ignore_missing=True)

    Delete an address scope

    Parameters:

      - address_scope – The value can be either the ID of an address scope or a `AddressScope` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the address scope does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent address scope.

    Returns:

      `None`

  find_address_scope(name_or_id, ignore_missing=True, **query)

    Find a single address scope

    Parameters:

      - name_or_id – The name or ID of an address scope.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `AddressScope` or None

  get_address_scope(address_scope)

    Get a single address scope

    Parameters:

      address_scope – The value can be the ID of an address scope or a `AddressScope` instance.

    Returns:

      One `AddressScope`

    Raises:

      `NotFoundException` when no resource can be found.

  address_scopes(**query)

    Return a generator of address scopes

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned.

      - `name`: Address scope name

      - `ip_version`: Address scope IP address version

      - `tenant_id`: Owner tenant ID

      - `shared`: Address scope is shared (boolean)

    Returns:

      A generator of address scope objects

    Return type:

      `AddressScope`

  update_address_scope(address_scope, **attrs)

    Update an address scope

    Parameters:

      - address_scope – Either the ID of an address scope or a `AddressScope` instance.

      - attrs – The attributes to update on the address scope represented by `value`.

    Returns:

      The updated address scope

    Return type:

      `AddressScope`

### Quota Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  delete_quota(quota, ignore_missing=True)

    Delete a quota (i.e. reset to the default quota)

    Parameters:

      - quota – The value can be either the ID of a quota or a `Quota` instance. The ID of a quota is the same as the project ID for the quota.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when quota does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent quota.

    Returns:

      `None`

  get_quota(quota, details=False)

    Get a quota

    Parameters:

      - quota – The value can be the ID of a quota or a `Quota` instance. The ID of a quota is the same as the project ID for the quota.

      - details – If set to True, details about quota usage will be returned.

    Returns:

      One `Quota`

    Raises:

      `NotFoundException` when no resource can be found.

  get_quota_default(quota)

    Get a default quota

    Parameters:

      quota – The value can be the ID of a default quota or a `QuotaDefault` instance. The ID of a default quota is the same as the project ID for the default quota.

    Returns:

      One `QuotaDefault`

    Raises:

      `NotFoundException` when no resource can be found.

  quotas(**query)

    Return a generator of quotas

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned. Currently no query parameter is supported.

    Returns:

      A generator of quota objects

    Return type:

      `Quota`

  update_quota(quota, **attrs)

    Update a quota

    Parameters:

      - quota – Either the ID of a quota or a `Quota` instance. The ID of a quota is the same as the project ID for the quota.

      - attrs – The attributes to update on the quota represented by `quota`.

    Returns:

      The updated quota

    Return type:

      `Quota`

### QoS Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_qos_bandwidth_limit_rule(qos_policy, **attrs)

    Create a new bandwidth limit rule

    Parameters:

      - attrs – Keyword arguments which will be used to create a `QoSBandwidthLimitRule`, comprised of the properties on the QoSBandwidthLimitRule class.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

    Returns:

      The results of resource creation

    Return type:

      `QoSBandwidthLimitRule`

  delete_qos_bandwidth_limit_rule(qos_rule, qos_policy, ignore_missing=True)

    Delete a bandwidth limit rule

    Parameters:

      - qos_rule – The value can be either the ID of a bandwidth limit rule or a `QoSBandwidthLimitRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent bandwidth limit rule.

    Returns:

      `None`

  find_qos_bandwidth_limit_rule(qos_rule_id, qos_policy, ignore_missing=True, **query)

    Find a bandwidth limit rule

    Parameters:

      - qos_rule_id – The ID of a bandwidth limit rule.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `QoSBandwidthLimitRule` or None

  get_qos_bandwidth_limit_rule(qos_rule, qos_policy)

    Get a single bandwidth limit rule

    Parameters:

      - qos_rule – The value can be the ID of a minimum bandwidth rule or a `QoSBandwidthLimitRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

    Returns:

      One `QoSBandwidthLimitRule`

    Raises:

      `NotFoundException` when no resource can be found.

  qos_bandwidth_limit_rules(qos_policy, **query)

    Return a generator of bandwidth limit rules

    Parameters:

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - query (kwargs) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of bandwidth limit rule objects

    Return type:

      `QoSBandwidthLimitRule`

  update_qos_bandwidth_limit_rule(qos_rule, qos_policy, **attrs)

    Update a bandwidth limit rule

    Parameters:

      - qos_rule – Either the id of a bandwidth limit rule or a `QoSBandwidthLimitRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - attrs – The attributes to update on the bandwidth limit rule represented by `qos_rule`.

    Returns:

      The updated minimum bandwidth rule

    Return type:

      `QoSBandwidthLimitRule`

  create_qos_dscp_marking_rule(qos_policy, **attrs)

    Create a new QoS DSCP marking rule

    Parameters:

      - attrs – Keyword arguments which will be used to create a `QoSDSCPMarkingRule`, comprised of the properties on the QosDscpMarkingRule class.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

    Returns:

      The results of router creation

    Return type:

      `QoSDSCPMarkingRule`

  delete_qos_dscp_marking_rule(qos_rule, qos_policy, ignore_missing=True)

    Delete a QoS DSCP marking rule

    Parameters:

      - qos_rule – The value can be either the ID of a minimum bandwidth rule or a `QoSDSCPMarkingRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent minimum bandwidth rule.

    Returns:

      `None`

  find_qos_dscp_marking_rule(qos_rule_id, qos_policy, ignore_missing=True, **query)

    Find a QoS DSCP marking rule

    Parameters:

      - qos_rule_id – The ID of a QoS DSCP marking rule.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `QoSDSCPMarkingRule` or None

  get_qos_dscp_marking_rule(qos_rule, qos_policy)

    Get a single QoS DSCP marking rule

    Parameters:

      - qos_rule – The value can be the ID of a minimum bandwidth rule or a `QoSDSCPMarkingRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

    Returns:

      One `QoSDSCPMarkingRule`

    Raises:

      `NotFoundException` when no resource can be found.

  qos_dscp_marking_rules(qos_policy, **query)

    Return a generator of QoS DSCP marking rules

    Parameters:

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - query (kwargs) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of QoS DSCP marking rule objects

    Return type:

      `QoSDSCPMarkingRule`

  update_qos_dscp_marking_rule(qos_rule, qos_policy, **attrs)

    Update a QoS DSCP marking rule

    Parameters:

      - qos_rule – Either the id of a minimum bandwidth rule or a `QoSDSCPMarkingRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - attrs – The attributes to update on the QoS DSCP marking rule represented by `qos_rule`.

    Returns:

      The updated QoS DSCP marking rule

    Return type:

      `QoSDSCPMarkingRule`

  create_qos_minimum_bandwidth_rule(qos_policy, **attrs)

    Create a new minimum bandwidth rule

    Parameters:

      - attrs – Keyword arguments which will be used to create a `QoSMinimumBandwidthRule`, comprised of the properties on the QoSMinimumBandwidthRule class.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

    Returns:

      The results of resource creation

    Return type:

      `QoSMinimumBandwidthRule`

  delete_qos_minimum_bandwidth_rule(qos_rule, qos_policy, ignore_missing=True)

    Delete a minimum bandwidth rule

    Parameters:

      - qos_rule – The value can be either the ID of a minimum bandwidth rule or a `QoSMinimumBandwidthRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent minimum bandwidth rule.

    Returns:

      `None`

  find_qos_minimum_bandwidth_rule(qos_rule_id, qos_policy, ignore_missing=True, **query)

    Find a minimum bandwidth rule

    Parameters:

      - qos_rule_id – The ID of a minimum bandwidth rule.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `QoSMinimumBandwidthRule` or None

  get_qos_minimum_bandwidth_rule(qos_rule, qos_policy)

    Get a single minimum bandwidth rule

    Parameters:

      - qos_rule – The value can be the ID of a minimum bandwidth rule or a `QoSMinimumBandwidthRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

    Returns:

      One `QoSMinimumBandwidthRule`

    Raises:

      `NotFoundException` when no resource can be found.

  qos_minimum_bandwidth_rules(qos_policy, **query)

    Return a generator of minimum bandwidth rules

    Parameters:

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - query (kwargs) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of minimum bandwidth rule objects

    Return type:

      `QoSMinimumBandwidthRule`

  update_qos_minimum_bandwidth_rule(qos_rule, qos_policy, **attrs)

    Update a minimum bandwidth rule

    Parameters:

      - qos_rule – Either the id of a minimum bandwidth rule or a `QoSMinimumBandwidthRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - attrs – The attributes to update on the minimum bandwidth rule represented by `qos_rule`.

    Returns:

      The updated minimum bandwidth rule

    Return type:

      `QoSMinimumBandwidthRule`

  create_qos_minimum_packet_rate_rule(qos_policy, **attrs)

    Create a new minimum packet rate rule

    Parameters:

      - attrs – Keyword arguments which will be used to create a `QoSMinimumPacketRateRule`, comprised of the properties on the QoSMinimumPacketRateRule class.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

    Returns:

      The results of resource creation

    Return type:

      `QoSMinimumPacketRateRule`

  delete_qos_minimum_packet_rate_rule(qos_rule, qos_policy, ignore_missing=True)

    Delete a minimum packet rate rule

    Parameters:

      - qos_rule – The value can be either the ID of a minimum packet rate rule or a `QoSMinimumPacketRateRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent minimum packet rate rule.

    Returns:

      `None`

  find_qos_minimum_packet_rate_rule(qos_rule_id, qos_policy, ignore_missing=True, **query)

    Find a minimum packet rate rule

    Parameters:

      - qos_rule_id – The ID of a minimum packet rate rule.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `QoSMinimumPacketRateRule` or None

  get_qos_minimum_packet_rate_rule(qos_rule, qos_policy)

    Get a single minimum packet rate rule

    Parameters:

      - qos_rule – The value can be the ID of a minimum packet rate rule or a `QoSMinimumPacketRateRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

    Returns:

      One `QoSMinimumPacketRateRule`

    Raises:

      `NotFoundException` when no resource can be found.

  qos_minimum_packet_rate_rules(qos_policy, **query)

    Return a generator of minimum packet rate rules

    Parameters:

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - query (kwargs) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of minimum packet rate rule objects

    Return type:

      `QoSMinimumPacketRateRule`

  update_qos_minimum_packet_rate_rule(qos_rule, qos_policy, **attrs)

    Update a minimum packet rate rule

    Parameters:

      - qos_rule – Either the id of a minimum packet rate rule or a `QoSMinimumPacketRateRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - attrs – The attributes to update on the minimum packet rate rule represented by `qos_rule`.

    Returns:

      The updated minimum packet rate rule

    Return type:

      `QoSMinimumPacketRateRule`

  create_qos_packet_rate_limit_rule(qos_policy, **attrs)

    Create a new packet rate limit rule

    Parameters:

      - attrs – Keyword arguments which will be used to create a `QoSPacketRateLimitRule`, comprised of the properties on the QoSPacketRateLimitRule class.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

    Returns:

      The results of resource creation

    Return type:

      `QoSPacketRateLimitRule`

  delete_qos_packet_rate_limit_rule(qos_rule, qos_policy, ignore_missing=True)

    Delete a packet rate limit rule

    Parameters:

      - qos_rule – The value can be either the ID of a packet rate limit rule or a `QoSPacketRateLimitRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent minimum packet rate rule.

    Returns:

      `None`

  find_qos_packet_rate_limit_rule(qos_rule_id, qos_policy, ignore_missing=True, **query)

    Find a packet rate limit rule

    Parameters:

      - qos_rule_id – The ID of a packet rate limit rule.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `QoSPacketRateLimitRule` or None

  get_qos_packet_rate_limit_rule(qos_rule, qos_policy)

    Get a single packet rate limit rule

    Parameters:

      - qos_rule – The value can be the ID of a packet rate limit rule or a `QoSPacketRateLimitRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

    Returns:

      One `QoSPacketRateLimitRule`

    Raises:

      `NotFoundException` when no resource can be found.

  update_qos_packet_rate_limit_rule(qos_rule, qos_policy, **attrs)

    Update a minimum packet rate rule

    Parameters:

      - qos_rule – Either the id of a minimum packet rate rule or a `QoSPacketRateLimitRule` instance.

      - qos_policy – The value can be the ID of the QoS policy that the rule belongs or a `QoSPolicy` instance.

      - attrs – The attributes to update on the minimum packet rate rule represented by `qos_rule`.

    Returns:

      The updated minimum packet rate rule

    Return type:

      `QoSPacketRateLimitRule`

  create_qos_policy(**attrs)

    Create a new QoS policy from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `QoSPolicy`, comprised of the properties on the QoSPolicy class.

    Returns:

      The results of QoS policy creation

    Return type:

      `QoSPolicy`

  delete_qos_policy(qos_policy, ignore_missing=True)

    Delete a QoS policy

    Parameters:

      - qos_policy – The value can be either the ID of a QoS policy or a `QoSPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the QoS policy does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent QoS policy.

    Returns:

      `None`

  find_qos_policy(name_or_id, ignore_missing=True, **query)

    Find a single QoS policy

    Parameters:

      - name_or_id – The name or ID of a QoS policy.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `QoSPolicy` or None

  get_qos_policy(qos_policy)

    Get a single QoS policy

    Parameters:

      qos_policy – The value can be the ID of a QoS policy or a `QoSPolicy` instance.

    Returns:

      One `QoSPolicy`

    Raises:

      `NotFoundException` when no resource can be found.

  qos_policies(**query)

    Return a generator of QoS policies

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Valid parameters are:

      - `description`: The description of a QoS policy.

      - `is_shared`: Whether the policy is shared among projects.

      - `name`: The name of a QoS policy.

      - `project_id`: The ID of the project who owns the network.

    Returns:

      A generator of QoS policy objects

    Return type:

      `QoSPolicy`

  update_qos_policy(qos_policy, **attrs)

    Update a QoS policy

    Parameters:

      - qos_policy – Either the id of a QoS policy or a `QoSPolicy` instance.

      - attrs – The attributes to update on the QoS policy represented by `qos_policy`.

    Returns:

      The updated QoS policy

    Return type:

      `QoSPolicy`

  find_qos_rule_type(rule_type_name, ignore_missing=True)

    Find a single QoS rule type details

    Parameters:

      - rule_type_name – The name of a QoS rule type.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

    Returns:

      One `QoSRuleType` or None

  get_qos_rule_type(qos_rule_type)

    Get details about single QoS rule type

    Parameters:

      qos_rule_type – The value can be the name of a QoS policy rule type or a `QoSRuleType` instance.

    Returns:

      One `QoSRuleType`

    Raises:

      `NotFoundException` when no resource can be found.

  qos_rule_types(**query)

    Return a generator of QoS rule types

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources returned. Valid parameters include:

      - `type`: The type of the QoS rule type.

    Returns:

      A generator of QoS rule type objects

    Return type:

      `QoSRuleType`

### Agent Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  agents(**query)

    Return a generator of network agents

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned.

      - `agent_type`: Agent type.

      - `availability_zone`: The availability zone for an agent.

      - `binary`: The name of the agent’s application binary.

      - `description`: The description of the agent.

      - `host`: The host (host name or host address) the agent is running on.

      - `topic`: The message queue topic used.

      - `is_admin_state_up`: The administrative state of the agent.

      - `is_alive`: Whether the agent is alive.

    Returns:

      A generator of agents

    Return type:

      `Agent`

  delete_agent(agent, ignore_missing=True)

    Delete a network agent

    Parameters:

      - agent – The value can be the ID of a agent or a `Agent` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the agent does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent agent.

    Returns:

      `None`

  get_agent(agent)

    Get a single network agent

    Parameters:

      agent – The value can be the ID of a agent or a `Agent` instance.

    Returns:

      One `Agent`

    Return type:

      `Agent`

    Raises:

      `NotFoundException` when no resource can be found.

  update_agent(agent, **attrs)

    Update a network agent

    Parameters:

      - agent – The value can be the ID of a agent or a `Agent` instance.

      - attrs – The attributes to update on the agent represented by `value`.

    Returns:

      One `Agent`

    Return type:

      `Agent`

  network_hosting_dhcp_agents(network, **query)

    A generator of DHCP agents hosted on a network.

    Parameters:

      - network – The instance of `Network`

      - query (dict) – Optional query parameters to be sent to limit the resources returned.

    Returns:

      A generator of hosted DHCP agents

  routers_hosting_l3_agents(router, **query)

    Return a generator of L3 agent hosting a router

    Parameters:

      - router – Either the router id or an instance of `Router`

      - query (kwargs) – Optional query parameters to be sent to limit the resources returned

    Returns:

      A generator of Router L3 Agents

    Return type:

      `RouterL3Agents`

  agent_hosted_routers(agent, **query)

    Return a generator of routers hosted by a L3 agent

    Parameters:

      - agent – Either the agent id of an instance of `Agent`

      - query (kwargs) – Optional query parameters to be sent to limit the resources returned

    Returns:

      A generator of routers

    Return type:

      `L3AgentRouters`

  add_router_to_agent(agent, router)

    Add router to L3 agent

    Parameters:

      - agent – Either the id of an agent `Agent` instance

      - router – A router instance

    Returns:

      Agent with attached router

    Return type:

      `Agent`

  remove_router_from_agent(agent, router)

    Remove router from L3 agent

    Parameters:

      - agent – Either the id of an agent or an `Agent` instance

      - router – A router instance

    Returns:

      Agent with removed router

    Return type:

      `Agent`

### RBAC Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_rbac_policy(**attrs)

    Create a new RBAC policy from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `RBACPolicy`, comprised of the properties on the RBACPolicy class.

    Returns:

      The results of RBAC policy creation

    Return type:

      `RBACPolicy`

  delete_rbac_policy(rbac_policy, ignore_missing=True)

    Delete a RBAC policy

    Parameters:

      - rbac_policy – The value can be either the ID of a RBAC policy or a `RBACPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the RBAC policy does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent RBAC policy.

    Returns:

      `None`

  find_rbac_policy(rbac_policy, ignore_missing=True, **query)

    Find a single RBAC policy

    Parameters:

      - rbac_policy – The ID of a RBAC policy.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `RBACPolicy` or None

  get_rbac_policy(rbac_policy)

    Get a single RBAC policy

    Parameters:

      rbac_policy – The value can be the ID of a RBAC policy or a `RBACPolicy` instance.

    Returns:

      One `RBACPolicy`

    Raises:

      `NotFoundException` when no resource can be found.

  rbac_policies(**query)

    Return a generator of RBAC policies

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Available parameters include:

      - `action`: RBAC policy action

      - `object_type`: Type of the object that the RBAC policy affects

      - `target_project_id`: ID of the tenant that the RBAC policy affects

      - `project_id`: Owner tenant ID

    Returns:

      A generator of rbac objects

    Return type:

      `RBACPolicy`

  update_rbac_policy(rbac_policy, **attrs)

    Update a RBAC policy

    Parameters:

      - rbac_policy – Either the id of a RBAC policy or a `RBACPolicy` instance.

      - attrs – The attributes to update on the RBAC policy represented by `rbac_policy`.

    Returns:

      The updated RBAC policy

    Return type:

      `RBACPolicy`

### Listener Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_listener(**attrs)

    Create a new listener from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `Listener`, comprised of the properties on the Listener class.

    Returns:

      The results of listener creation

    Return type:

      `Listener`

  delete_listener(listener, ignore_missing=True)

    Delete a listener

    Parameters:

      - listener – The value can be either the ID of a listner or a `Listener` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the listner does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent listener.

    Returns:

      `None`

  find_listener(name_or_id, ignore_missing=True, **query)

    Find a single listener

    Parameters:

      - name_or_id – The name or ID of a listener.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `Listener` or None

  get_listener(listener)

    Get a single listener

    Parameters:

      listener – The value can be the ID of a listener or a `Listener` instance.

    Returns:

      One `Listener`

    Raises:

      `NotFoundException` when no resource can be found.

  listeners(**query)

    Return a generator of listeners

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Valid parameters are:

      - `connection_limit`: The maximum number of connections permitted for the load-balancer.

      - `default_pool_id`: The ID of the default pool.

      - `default_tls_container_ref`: A reference to a container of TLS secret.

      - `description`: The description of a listener.

      - `is_admin_state_up`: The administrative state of the listener.

      - `name`: The name of a listener.

      - `project_id`: The ID of the project associated with a listener.

      - `protocol`: The protocol of the listener.

      - `protocol_port`: Port the listener will listen to.

    Returns:

      A generator of listener objects

    Return type:

      `Listener`

  update_listener(listener, **attrs)

    Update a listener

    Parameters:

      - listener – Either the id of a listener or a `Listener` instance.

      - attrs – The attributes to update on the listener represented by `listener`.

    Returns:

      The updated listener

    Return type:

      `Listener`

### Subnet Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_subnet(**attrs)

    Create a new subnet from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `Subnet`, comprised of the properties on the Subnet class.

    Returns:

      The results of subnet creation

    Return type:

      `Subnet`

  delete_subnet(subnet, ignore_missing=True, if_revision=None)

    Delete a subnet

    Parameters:

      - subnet – The value can be either the ID of a subnet or a `Subnet` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the subnet does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent subnet.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

    Returns:

      `None`

  find_subnet(name_or_id, ignore_missing=True, **query)

    Find a single subnet

    Parameters:

      - name_or_id – The name or ID of a subnet.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `Subnet` or None

  get_subnet(subnet)

    Get a single subnet

    Parameters:

      subnet – The value can be the ID of a subnet or a `Subnet` instance.

    Returns:

      One `Subnet`

    Raises:

      `NotFoundException` when no resource can be found.

  subnets(**query)

    Return a generator of subnets

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Available parameters include:

      - `cidr`: Subnet CIDR

      - `description`: The subnet description

      - `gateway_ip`: Subnet gateway IP address

      - `ip_version`: Subnet IP address version

      - `ipv6_address_mode`: The IPv6 address mode

      - `ipv6_ra_mode`: The IPv6 router advertisement mode

      - `is_dhcp_enabled`: Subnet has DHCP enabled (boolean)

      - `name`: Subnet name

      - `network_id`: ID of network that owns the subnets

      - `project_id`: Owner tenant ID

      - `subnet_pool_id`: The subnet pool ID from which to obtain a CIDR.

    Returns:

      A generator of subnet objects

    Return type:

      `Subnet`

  update_subnet(subnet, if_revision=None, **attrs)

    Update a subnet

    Parameters:

      - subnet – Either the id of a subnet or a `Subnet` instance.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

      - attrs – The attributes to update on the subnet represented by `subnet`.

    Returns:

      The updated subnet

    Return type:

      `Subnet`

  create_subnet_pool(**attrs)

    Create a new subnet pool from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `SubnetPool`, comprised of the properties on the SubnetPool class.

    Returns:

      The results of subnet pool creation

    Return type:

      `SubnetPool`

  delete_subnet_pool(subnet_pool, ignore_missing=True)

    Delete a subnet pool

    Parameters:

      - subnet_pool – The value can be either the ID of a subnet pool or a `SubnetPool` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the subnet pool does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent subnet pool.

    Returns:

      `None`

  find_subnet_pool(name_or_id, ignore_missing=True, **query)

    Find a single subnet pool

    Parameters:

      - name_or_id – The name or ID of a subnet pool.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `SubnetPool` or None

  get_subnet_pool(subnet_pool)

    Get a single subnet pool

    Parameters:

      subnet_pool – The value can be the ID of a subnet pool or a `SubnetPool` instance.

    Returns:

      One `SubnetPool`

    Raises:

      `NotFoundException` when no resource can be found.

  subnet_pools(**query)

    Return a generator of subnet pools

    Parameters:

      query (kwargs) –

      Optional query parameters to be sent to limit the resources being returned. Available parameters include:

      - `address_scope_id`: Subnet pool address scope ID

      - `description`: The subnet pool description

      - `ip_version`: The IP address family

      - `is_default`: Subnet pool is the default (boolean)

      - `is_shared`: Subnet pool is shared (boolean)

      - `name`: Subnet pool name

      - `project_id`: Owner tenant ID

    Returns:

      A generator of subnet pool objects

    Return type:

      `SubnetPool`

  update_subnet_pool(subnet_pool, **attrs)

    Update a subnet pool

    Parameters:

      - subnet_pool – Either the ID of a subnet pool or a `SubnetPool` instance.

      - attrs – The attributes to update on the subnet pool represented by `subnet_pool`.

    Returns:

      The updated subnet pool

    Return type:

      `SubnetPool`

### Load Balancer Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_load_balancer(**attrs)

    Create a new load balancer from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `LoadBalancer`, comprised of the properties on the LoadBalancer class.

    Returns:

      The results of load balancer creation

    Return type:

      `LoadBalancer`

  delete_load_balancer(load_balancer, ignore_missing=True)

    Delete a load balancer

    Parameters:

      - load_balancer – The value can be the ID of a load balancer or a `LoadBalancer` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the load balancer does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent load balancer.

    Returns:

      `None`

  find_load_balancer(name_or_id, ignore_missing=True, **query)

    Find a single load balancer

    Parameters:

      - name_or_id – The name or ID of a load balancer.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `LoadBalancer` or None

  get_load_balancer(load_balancer)

    Get a single load balancer

    Parameters:

      load_balancer – The value can be the ID of a load balancer or a `LoadBalancer` instance.

    Returns:

      One `LoadBalancer`

    Raises:

      `NotFoundException` when no resource can be found.

  load_balancers(**query)

    Return a generator of load balancers

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of load balancer objects

    Return type:

      `LoadBalancer`

  update_load_balancer(load_balancer, **attrs)

    Update a load balancer

    Parameters:

      - load_balancer – Either the id of a load balancer or a `LoadBalancer` instance.

      - attrs – The attributes to update on the load balancer represented by `load_balancer`.

    Returns:

      The updated load balancer

    Return type:

      `LoadBalancer`

### Health Monitor Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_health_monitor(**attrs)

    Create a new health monitor from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `HealthMonitor`, comprised of the properties on the HealthMonitor class.

    Returns:

      The results of health monitor creation

    Return type:

      `HealthMonitor`

  delete_health_monitor(health_monitor, ignore_missing=True)

    Delete a health monitor

    Parameters:

      - health_monitor – The value can be either the ID of a health monitor or a `HealthMonitor` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the health monitor does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent health monitor.

    Returns:

      `None`

  find_health_monitor(name_or_id, ignore_missing=True, **query)

    Find a single health monitor

    Parameters:

      - name_or_id – The name or ID of a health monitor.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `HealthMonitor` or None

  get_health_monitor(health_monitor)

    Get a single health monitor

    Parameters:

      health_monitor – The value can be the ID of a health monitor or a `HealthMonitor` instance.

    Returns:

      One `HealthMonitor`

    Raises:

      `NotFoundException` when no resource can be found.

  health_monitors(**query)

    Return a generator of health monitors

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Valid parameters are:

      - `delay`: the time in milliseconds between sending probes.

      - `expected_codes`: The expected HTTP codes for a pssing HTTP(S) monitor.

      - `http_method`: The HTTP method a monitor uses for requests.

      - `is_admin_state_up`: The administrative state of a health monitor.

      - `max_retries`: The maximum consecutive health probe attempts.

      - `project_id`: The ID of the project this health monitor is associated with.

      - `timeout`: The maximum number of milliseconds for a monitor to wait for a connection to be established before it times out.

      - `type`: The type of probe sent by the load balancer for health check, which can be `PING`, `TCP`, `HTTP` or `HTTPS`.

      - `url_path`: The path portion of a URI that will be probed.

    Returns:

      A generator of health monitor objects

    Return type:

      `HealthMonitor`

  update_health_monitor(health_monitor, **attrs)

    Update a health monitor

    Parameters:

      - health_monitor – Either the id of a health monitor or a `HealthMonitor` instance.

      - attrs – The attributes to update on the health monitor represented by `value`.

    Returns:

      The updated health monitor

    Return type:

      `HealthMonitor`

### Metering Label Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_metering_label(**attrs)

    Create a new metering label from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `MeteringLabel`, comprised of the properties on the MeteringLabel class.

    Returns:

      The results of metering label creation

    Return type:

      `MeteringLabel`

  delete_metering_label(metering_label, ignore_missing=True)

    Delete a metering label

    Parameters:

      - metering_label – The value can be either the ID of a metering label or a `MeteringLabel` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the metering label does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent metering label.

    Returns:

      `None`

  find_metering_label(name_or_id, ignore_missing=True, **query)

    Find a single metering label

    Parameters:

      - name_or_id – The name or ID of a metering label.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `MeteringLabel` or None

  get_metering_label(metering_label)

    Get a single metering label

    Parameters:

      metering_label – The value can be the ID of a metering label or a `MeteringLabel` instance.

    Returns:

      One `MeteringLabel`

    Raises:

      `NotFoundException` when no resource can be found.

  metering_labels(**query)

    Return a generator of metering labels

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Valid parameters are:

      - `description`: Description of a metering label.

      - `name`: Name of a metering label.

      - `is_shared`: Boolean indicating whether a metering label is shared.

      - `project_id`: The ID of the project a metering label is associated with.

    Returns:

      A generator of metering label objects

    Return type:

      `MeteringLabel`

  update_metering_label(metering_label, **attrs)

    Update a metering label

    Parameters:

      - metering_label – Either the id of a metering label or a `MeteringLabel` instance.

      - attrs – The attributes to update on the metering label represented by `metering_label`.

    Returns:

      The updated metering label

    Return type:

      `MeteringLabel`

  create_metering_label_rule(**attrs)

    Create a new metering label rule from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `MeteringLabelRule`, comprised of the properties on the MeteringLabelRule class.

    Returns:

      The results of metering label rule creation

    Return type:

      `MeteringLabelRule`

  delete_metering_label_rule(metering_label_rule, ignore_missing=True)

    Delete a metering label rule

    Parameters:

      - metering_label_rule – The value can be either the ID of a metering label rule or a `MeteringLabelRule` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the metering label rule does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent metering label rule.

    Returns:

      `None`

  find_metering_label_rule(name_or_id, ignore_missing=True, **query)

    Find a single metering label rule

    Parameters:

      - name_or_id – The name or ID of a metering label rule.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `MeteringLabelRule` or None

  get_metering_label_rule(metering_label_rule)

    Get a single metering label rule

    Parameters:

      metering_label_rule – The value can be the ID of a metering label rule or a `MeteringLabelRule` instance.

    Returns:

      One `MeteringLabelRule`

    Raises:

      `NotFoundException` when no resource can be found.

  metering_label_rules(**query)

    Return a generator of metering label rules

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Valid parameters are:

      - `direction`: The direction in which metering label rule is applied.

      - `metering_label_id`: The ID of a metering label this rule is associated with.

      - `project_id`: The ID of the project the metering label rule is associated with.

      - `remote_ip_prefix`: The remote IP prefix to be associated with this metering label rule.

    Returns:

      A generator of metering label rule objects

    Return type:

      `MeteringLabelRule`

  update_metering_label_rule(metering_label_rule, **attrs)

    Update a metering label rule

    Parameters:

      - metering_label_rule – Either the id of a metering label rule or a `MeteringLabelRule` instance.

      - attrs – The attributes to update on the metering label rule represented by `metering_label_rule`.

    Returns:

      The updated metering label rule

    Return type:

      `MeteringLabelRule`

### Segment Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_segment(**attrs)

    Create a new segment from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `Segment`, comprised of the properties on the Segment class.

    Returns:

      The results of segment creation

    Return type:

      `Segment`

  delete_segment(segment, ignore_missing=True)

    Delete a segment

    Parameters:

      - segment – The value can be either the ID of a segment or a `Segment` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the segment does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent segment.

    Returns:

      `None`

  find_segment(name_or_id, ignore_missing=True, **query)

    Find a single segment

    Parameters:

      - name_or_id – The name or ID of a segment.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `Segment` or None

  get_segment(segment)

    Get a single segment

    Parameters:

      segment – The value can be the ID of a segment or a `Segment` instance.

    Returns:

      One `Segment`

    Raises:

      `NotFoundException` when no resource can be found.

  segments(**query)

    Return a generator of segments

    Parameters:

      query (kwargs) –

      Optional query parameters to be sent to limit the resources being returned. Available parameters include:

      - `description`: The segment description

      - `name`: Name of the segments

      - `network_id`: ID of the network that owns the segments

      - `network_type`: Network type for the segments

      - `physical_network`: Physical network name for the segments

      - `segmentation_id`: Segmentation ID for the segments

    Returns:

      A generator of segment objects

    Return type:

      `Segment`

  update_segment(segment, **attrs)

    Update a segment

    Parameters:

      - segment – Either the id of a segment or a `Segment` instance.

      - attrs – The attributes to update on the segment represented by `segment`.

    Returns:

      The update segment

    Return type:

      `Segment`

### Flavor Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_flavor(**attrs)

    Create a new network service flavor from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `Flavor`, comprised of the properties on the Flavor class.

    Returns:

      The results of flavor creation

    Return type:

      `Flavor`

  delete_flavor(flavor, ignore_missing=True)

    Delete a network service flavor

    Parameters:

      - flavor – The value can be either the ID of a flavor or a `Flavor` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the flavor does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent flavor.

    Returns:

      `None`

  find_flavor(name_or_id, ignore_missing=True, **query)

    Find a single network service flavor

    Parameters:

      - name_or_id – The name or ID of a flavor.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `Flavor` or None

  get_flavor(flavor)

    Get a single network service flavor

    Parameters:

      flavor – The value can be the ID of a flavor or a `Flavor` instance.

    Returns:

      One `Flavor`

    Raises:

      `NotFoundException` when no resource can be found.

  update_flavor(flavor, **attrs)

    Update a network service flavor

    Parameters:

      - flavor – Either the id of a flavor or a `Flavor` instance.

      - attrs – The attributes to update on the flavor represented by `flavor`.

    Returns:

      The updated flavor

    Return type:

      `Flavor`

  flavors(**query)

    Return a generator of network service flavors

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Valid parameters include:

      - `description`: The description of a flavor.

      - `is_enabled`: Whether a flavor is enabled.

      - `name`: The name of a flavor.

      - `service_type`: The service type to which a falvor applies.

    Returns:

      A generator of flavor objects

    Return type:

      `Flavor`

### Service Profile Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  associate_flavor_with_service_profile(flavor, service_profile)

    Associate network flavor with service profile.

    Parameters:

      - flavor – Either the id of a flavor or a `Flavor` instance.

      - service_profile – The value can be either the ID of a service profile or a `ServiceProfile` instance.

    Returns:

  disassociate_flavor_from_service_profile(flavor, service_profile)

    Disassociate network flavor from service profile.

    Parameters:

      - flavor – Either the id of a flavor or a `Flavor` instance.

      - service_profile – The value can be either the ID of a service profile or a `ServiceProfile` instance.

    Returns:

  create_service_profile(**attrs)

    Create a new network service flavor profile from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `ServiceProfile`, comprised of the properties on the ServiceProfile class.

    Returns:

      The results of service profile creation

    Return type:

      `ServiceProfile`

  delete_service_profile(service_profile, ignore_missing=True)

    Delete a network service flavor profile

    Parameters:

      - service_profile – The value can be either the ID of a service profile or a `ServiceProfile` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the service profile does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent service profile.

    Returns:

      `None`

  find_service_profile(name_or_id, ignore_missing=True, **query)

    Find a single network service flavor profile

    Parameters:

      - name_or_id – The name or ID of a service profile.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `ServiceProfile` or None

  get_service_profile(service_profile)

    Get a single network service flavor profile

    Parameters:

      service_profile – The value can be the ID of a service_profile or a `ServiceProfile` instance.

    Returns:

      One `ServiceProfile`

    Raises:

      `NotFoundException` when no resource can be found.

  service_profiles(**query)

    Return a generator of network service flavor profiles

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources returned. Available parameters inclue:

      - `description`: The description of the service flavor profile

      - `driver`: Provider driver for the service flavor profile

      - `is_enabled`: Whether the profile is enabled

      - `project_id`: The owner project ID

    Returns:

      A generator of service profile objects

    Return type:

      `ServiceProfile`

  update_service_profile(service_profile, **attrs)

    Update a network flavor service profile

    Parameters:

      - service_profile – Either the id of a service profile or a `ServiceProfile` instance.

      - attrs – The attributes to update on the service profile represented by `service_profile`.

    Returns:

      The updated service profile

    Return type:

      `ServiceProfile`

### Tag Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  set_tags(resource, tags)

    Replace tags of a specified resource with specified tags

    Parameters:

      - resource – `Resource` instance.

      - tags ("list") – New tags to be set.

    Returns:

      The updated resource

    Return type:

      `Resource`

### VPNaaS Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_vpn_endpoint_group(**attrs)

    Create a new vpn endpoint group from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `VpnEndpointGroup`, comprised of the properties on the VpnEndpointGroup class.

    Returns:

      The results of vpn endpoint group creation.

    Return type:

      `VpnEndpointGroup`

  delete_vpn_endpoint_group(vpn_endpoint_group, ignore_missing=True)

    Delete a vpn service

    Parameters:

      - vpn_endpoint_group – The value can be either the ID of a vpn service or a `VpnEndpointGroup` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the vpn service does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent vpn service.

    Returns:

      `None`

  find_vpn_endpoint_group(name_or_id, ignore_missing=True, **query)

    Find a single vpn service

    Parameters:

      - name_or_id – The name or ID of a vpn service.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `VpnEndpointGroup` or None

  get_vpn_endpoint_group(vpn_endpoint_group)

    Get a single vpn service

    Parameters:

      vpn_endpoint_group – The value can be the ID of a vpn service or a `VpnEndpointGroup` instance.

    Returns:

      One `VpnEndpointGroup`

    Raises:

      `NotFoundException` when no resource can be found.

  vpn_endpoint_groups(**query)

    Return a generator of vpn services

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of vpn service objects

    Return type:

      `VpnEndpointGroup`

  update_vpn_endpoint_group(vpn_endpoint_group, **attrs)

    Update a vpn service

    Parameters:

      - vpn_endpoint_group – Either the id of a vpn service or a `VpnEndpointGroup` instance.

      - attrs – The attributes to update on the VPN service represented by `vpn_endpoint_group`.

    Returns:

      The updated vpnservice

    Return type:

      `VpnEndpointGroup`

  create_vpn_ipsec_site_connection(**attrs)

    Create a new IPsec site connection from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `VpnIPSecSiteConnection`, comprised of the properties on the IPSecSiteConnection class.

    Returns:

      The results of IPsec site connection creation

    Return type:

      `VpnIPSecSiteConnection`

  find_vpn_ipsec_site_connection(name_or_id, ignore_missing=True, **query)

    Find a single IPsec site connection

    Parameters:

      - name_or_id – The name or ID of an IPsec site connection.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods such as query filters.

    Returns:

      One `VpnIPSecSiteConnection` or None

  get_vpn_ipsec_site_connection(ipsec_site_connection)

    Get a single IPsec site connection

    Parameters:

      ipsec_site_connection – The value can be the ID of an IPsec site connection or a `VpnIPSecSiteConnection` instance.

    Returns:

      One `VpnIPSecSiteConnection`

    Raises:

      `NotFoundException` when no resource can be found.

  vpn_ipsec_site_connections(**query)

    Return a generator of IPsec site connections

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of IPsec site connection objects

    Return type:

      `VpnIPSecSiteConnection`

  update_vpn_ipsec_site_connection(ipsec_site_connection, **attrs)

    Update a IPsec site connection

    Ipsec_site_connection:

      Either the id of an IPsec site connection or a `VpnIPSecSiteConnection` instance.

    Parameters:

      attrs – The attributes to update on the IPsec site connection represented by `ipsec_site_connection`.

    Returns:

      The updated IPsec site connection

    Return type:

      `VpnIPSecSiteConnection`

  delete_vpn_ipsec_site_connection(ipsec_site_connection, ignore_missing=True)

    Delete a IPsec site connection

    Parameters:

      - ipsec_site_connection – The value can be either the ID of an IPsec site connection, or a `VpnIPSecSiteConnection` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the IPsec site connection does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent IPsec site connection.

    Returns:

      `None`

  create_vpn_ike_policy(**attrs)

    Create a new ike policy from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `VpnIkePolicy`, comprised of the properties on the VpnIkePolicy class.

    Returns:

      The results of ike policy creation :rtype: `VpnIkePolicy`

  find_vpn_ike_policy(name_or_id, ignore_missing=True, **query)

    Find a single ike policy

    Parameters:

      - name_or_id – The name or ID of an IKE policy.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods such as query filters.

    Returns:

      One `VpnIkePolicy` or None.

  get_vpn_ike_policy(ike_policy)

    Get a single ike policy

    Parameters:

      ike_policy – The value can be the ID of an IKE policy or a `VpnIkePolicy` instance.

    Returns:

      One `VpnIkePolicy`

    Return type:

      `VpnIkePolicy`

    Raises:

      `NotFoundException` when no resource can be found.

  vpn_ike_policies(**query)

    Return a generator of IKE policies

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of ike policy objects

    Return type:

      `VpnIkePolicy`

  update_vpn_ike_policy(ike_policy, **attrs)

    Update an IKE policy

    Ike_policy:

      Either the IK of an IKE policy or a `VpnIkePolicy` instance.

    Parameters:

      attrs – The attributes to update on the ike policy represented by `ike_policy`.

    Returns:

      The updated ike policy

    Return type:

      `VpnIkePolicy`

  delete_vpn_ike_policy(ike_policy, ignore_missing=True)

    Delete an IKE policy

    Parameters:

      - ike_policy – The value can be either the ID of an ike policy, or a `VpnIkePolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the ike policy does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent ike policy.

    Returns:

      `None`

  create_vpn_ipsec_policy(**attrs)

    Create a new IPsec policy from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `VpnIpsecPolicy`, comprised of the properties on the VpnIpsecPolicy class.

    Returns:

      The results of IPsec policy creation :rtype: `VpnIpsecPolicy`

  find_vpn_ipsec_policy(name_or_id, ignore_missing=True, **query)

    Find a single IPsec policy

    Parameters:

      - name_or_id – The name or ID of an IPsec policy.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods such as query filters.

    Returns:

      One `VpnIpsecPolicy` or None.

  get_vpn_ipsec_policy(ipsec_policy)

    Get a single IPsec policy

    Parameters:

      ipsec_policy – The value can be the ID of an IPcec policy or a `VpnIpsecPolicy` instance.

    Returns:

      One `VpnIpsecPolicy`

    Return type:

      `VpnIpsecPolicy`

    Raises:

      `NotFoundException` when no resource can be found.

  vpn_ipsec_policies(**query)

    Return a generator of IPsec policies

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of IPsec policy objects

    Return type:

      `VpnIpsecPolicy`

  update_vpn_ipsec_policy(ipsec_policy, **attrs)

    Update an IPsec policy

    Ipsec_policy:

      Either the id of an IPsec policy or a `VpnIpsecPolicy` instance.

    Parameters:

      attrs – The attributes to update on the IPsec policy represented by `ipsec_policy`.

    Returns:

      The updated IPsec policy

    Return type:

      `VpnIpsecPolicy`

  delete_vpn_ipsec_policy(ipsec_policy, ignore_missing=True)

    Delete an IPsec policy

    Parameters:

      - ipsec_policy – The value can be either the ID of an IPsec policy, or a `VpnIpsecPolicy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the IPsec policy does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent IPsec policy.

    Returns:

      `None`

  create_vpn_service(**attrs)

    Create a new vpn service from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `VpnService`, comprised of the properties on the VpnService class.

    Returns:

      The results of vpn service creation

    Return type:

      `VpnService`

  delete_vpn_service(vpn_service, ignore_missing=True)

    Delete a vpn service

    Parameters:

      - vpn_service – The value can be either the ID of a vpn service or a `VpnService` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the vpn service does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent vpn service.

    Returns:

      `None`

  find_vpn_service(name_or_id, ignore_missing=True, **query)

    Find a single vpn service

    Parameters:

      - name_or_id – The name or ID of a vpn service.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `VpnService` or None

  get_vpn_service(vpn_service)

    Get a single vpn service

    Parameters:

      vpn_service – The value can be the ID of a vpn service or a `VpnService` instance.

    Returns:

      One `VpnService`

    Raises:

      `NotFoundException` when no resource can be found.

  vpn_services(**query)

    Return a generator of vpn services

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of vpn service objects

    Return type:

      `VpnService`

  update_vpn_service(vpn_service, **attrs)

    Update a vpn service

    Parameters:

      - vpn_service – Either the id of a vpn service or a `VpnService` instance.

      - attrs – The attributes to update on the VPN service represented by `vpn_service`.

    Returns:

      The updated vpnservice

    Return type:

      `VpnService`

### Extension Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  find_extension(name_or_id, ignore_missing=True, **query)

    Find a single extension

    Parameters:

      - name_or_id – The name or ID of a extension.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `Extension` or None

  extensions(**query)

    Return a generator of extensions

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned. Currently no parameter is supported.

    Returns:

      A generator of extension objects

    Return type:

      `Extension`

### Service Provider Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  service_providers(**query)

    Return a generator of service providers

    Parameters:

      query (kwargs) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of service provider objects

    Return type:

      `ServiceProvider`

### Local IP Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_local_ip(**attrs)

    Create a new local ip from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `LocalIP`, comprised of the properties on the LocalIP class.

    Returns:

      The results of local ip creation

    Return type:

      `LocalIP`

  delete_local_ip(local_ip, ignore_missing=True, if_revision=None)

    Delete a local ip

    Parameters:

      - local_ip – The value can be either the ID of a local ip or a `LocalIP` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the local ip does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent ip.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

    Returns:

      `None`

  find_local_ip(name_or_id, ignore_missing=True, **query)

    Find a local IP

    Parameters:

      - name_or_id – The name or ID of an local IP.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `LocalIP` or None

  get_local_ip(local_ip)

    Get a single local ip

    Parameters:

      local_ip – The value can be the ID of a local ip or a `LocalIP` instance.

    Returns:

      One `LocalIP`

    Raises:

      `NotFoundException` when no resource can be found.

  local_ips(**query)

    Return a generator of local ips

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned.

      - `name`: Local IP name

      - `description`: Local IP description

      - `project_id`: Owner project ID

      - `network_id`: Local IP network

      - `local_port_id`: Local port ID

      - `local_ip_address`: The IP address of a Local IP

      - `ip_mode`: The Local IP mode

    Returns:

      A generator of local ip objects

    Return type:

      `LocalIP`

  update_local_ip(local_ip, if_revision=None, **attrs)

    Update a local ip

    Parameters:

      - local_ip – Either the id of a local ip or a `LocalIP` instance.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

      - attrs – The attributes to update on the ip represented by `value`.

    Returns:

      The updated ip

    Return type:

      `LocalIP`

  create_local_ip_association(local_ip, **attrs)

    Create a new local ip association from attributes

    Parameters:

      - local_ip – The value can be the ID of a Local IP or a `LocalIP` instance.

      - attrs – Keyword arguments which will be used to create a `LocalIPAssociation`, comprised of the properties on the LocalIP class.

    Returns:

      The results of local ip association creation

    Return type:

      `LocalIPAssociation`

  delete_local_ip_association(local_ip, fixed_port_id, ignore_missing=True, if_revision=None)

    Delete a local ip association

    Parameters:

      - local_ip – The value can be the ID of a Local IP or a `LocalIP` instance.

      - fixed_port_id – The value can be either the fixed port ID or a :class: ~openstack.network.v2.local_ip_association.LocalIPAssociation instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the local ip association does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent ip.

      - if_revision (int) – Revision to put in If-Match header of update request to perform compare-and-swap update.

    Returns:

      `None`

  find_local_ip_association(name_or_id, local_ip, ignore_missing=True, **query)

    Find a local ip association

    Parameters:

      - name_or_id – The name or ID of local ip association.

      - local_ip – The value can be the ID of a Local IP or a `LocalIP` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `LocalIPAssociation` or None

  get_local_ip_association(local_ip_association, local_ip)

    Get a single local ip association

    Parameters:

      - local_ip – The value can be the ID of a Local IP or a `LocalIP` instance.

      - local_ip_association – The value can be the ID of a local ip association or a `LocalIPAssociation` instance.

    Returns:

      One `LocalIPAssociation`

    Raises:

      `NotFoundException` when no resource can be found.

  local_ip_associations(local_ip, **query)

    Return a generator of local ip associations

    Parameters:

      - local_ip – The value can be the ID of a Local IP or a `LocalIP` instance.

      - query (dict) –

        Optional query parameters to be sent to limit the resources being returned.

        - `fixed_port_id`: The ID of the port to which a local IP is associated

        - `fixed_ip`: The fixed ip address associated with a a Local IP

        - `host`: Host where local ip is associated

    Returns:

      A generator of local ip association objects

    Return type:

      `LocalIPAssociation`

### Ndp Proxy Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_ndp_proxy(**attrs)

    Create a new ndp proxy from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `NDPProxxy`, comprised of the properties on the NDPProxy class.

    Returns:

      The results of ndp proxy creation

    Return type:

      `NDPProxxy`

  get_ndp_proxy(ndp_proxy)

    Get a single ndp proxy

    Parameters:

      ndp_proxy – The value can be the ID of a ndp proxy or a `NDPProxy` instance.

    Returns:

      One `NDPProxy`

    Raises:

      `NotFoundException` when no resource can be found.

  find_ndp_proxy(ndp_proxy_id, ignore_missing=True, **query)

    Find a single ndp proxy

    Parameters:

      - ndp_proxy_id – The ID of a ndp proxy.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `NDPProxy` or None

  delete_ndp_proxy(ndp_proxy, ignore_missing=True)

    Delete a ndp proxy

    Parameters:

      - ndp_proxy – The value can be the ID of a ndp proxy or a `NDPProxy` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the router does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent ndp proxy.

    Returns:

      `None`

  ndp_proxies(**query)

    Return a generator of ndp proxies

    Parameters:

      query (dict) –

      Optional query parameters to be sent to limit the resources being returned. Valid parameters are:

      - `router_id`: The ID fo the router

      - `port_id`: The ID of internal port.

      - `ip_address`: The internal IP address

    Returns:

      A generator of port forwarding objects

    Return type:

      `PortForwarding`

  update_ndp_proxy(ndp_proxy, **attrs)

    Update a ndp proxy

    Parameters:

      - ndp_proxy – The value can be the ID of a ndp proxy or a `NDPProxy` instance.

      - attrs – The attributes to update on the ip represented by `value`.

    Returns:

      The updated ndp_proxy

    Return type:

      `NDPProxy`

### BGP Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_bgp_peer(**attrs)

    Create a new BGP Peer from attributes

  delete_bgp_peer(peer, ignore_missing=True)

    Delete a BGP Peer

  find_bgp_peer(name_or_id, ignore_missing=True, **query)

    Find a single BGP Peer

  get_bgp_peer(peer)

    Get a signle BGP Peer

  update_bgp_peer(peer, **attrs)

    Update a BGP Peer

  bgp_peers(**query)

    Return a generator of BGP Peers

  create_bgp_speaker(**attrs)

    Create a new BGP Speaker

  delete_bgp_speaker(speaker, ignore_missing=True)

    Delete a BGP Speaker

  find_bgp_speaker(name_or_id, ignore_missing=True, **query)

    Find a single BGP Peer

  get_bgp_speaker(speaker)

    Get a signle BGP Speaker

  update_bgp_speaker(speaker, **attrs)

    Update a BGP Speaker

  bgp_speakers(**query)

    Return a generator of BGP Peers

  add_bgp_peer_to_speaker(speaker, peer_id)

    Bind the BGP peer to the specified BGP Speaker.

  remove_bgp_peer_from_speaker(speaker, peer_id)

    Unbind the BGP peer from a BGP Speaker.

  add_gateway_network_to_speaker(speaker, network_id)

    Add a network to the specified BGP speaker.

  remove_gateway_network_from_speaker(speaker, network_id)

    Remove a network from the specified BGP speaker.

  get_advertised_routes_of_speaker(speaker)

    List all routes advertised by the specified BGP Speaker.

  get_bgp_dragents_hosting_speaker(speaker)

    List all BGP dynamic agents which are hosting the specified BGP Speaker.

  add_bgp_speaker_to_dragent(bgp_agent, bgp_speaker_id)

    Add a BGP Speaker to the specified dynamic routing agent.

  get_bgp_speakers_hosted_by_dragent(bgp_agent)

    List all BGP Seakers hosted on the specified dynamic routing agent.

  remove_bgp_speaker_from_dragent(bgp_agent, bgp_speaker_id)

    Delete the BGP Speaker hosted by the specified dynamic routing agent.

### Tap As A Service Operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_tap_flow(**attrs)

    Create a new Tap Flow from attributes

  delete_tap_flow(tap_flow, ignore_missing=True)

    Delete a Tap Flow

  find_tap_flow(name_or_id, ignore_missing=True, **query)

    Find a single Tap Service

  get_tap_flow(tap_flow)

    Get a signle Tap Flow

  update_tap_flow(tap_flow, **attrs)

    Update a Tap Flow

  tap_flows(**query)

    Return a generator of Tap Flows

  create_tap_service(**attrs)

    Create a new Tap Service from attributes

  delete_tap_service(tap_service, ignore_missing=True)

    Delete a Tap Service

  find_tap_service(name_or_id, ignore_missing=True, **query)

    Find a single Tap Service

  update_tap_service(tap_service, **attrs)

    Update a Tap Service

  tap_services(**query)

    Return a generator of Tap Services

### BGPVPN operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_bgpvpn(**attrs)

    Create a new BGPVPN

    Parameters:

      attrs – Keyword arguments which will be used to create a `BgpVpn`, comprised of the properties on the BGPVPN class, for details see the Neutron api-ref.

    Returns:

      The result of BGPVPN creation

    Return type:

      `BgpVpn`

  delete_bgpvpn(bgpvpn, ignore_missing=True)

    Delete a BGPVPN

    Parameters:

      - bgpvpn – The value can be either the ID of a bgpvpn or a `BgpVpn` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the BGPVPN does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent BGPVPN.

    Returns:

      `None`

  find_bgpvpn(name_or_id, ignore_missing=True, **query)

    Find a single BGPVPN

    Parameters:

      - name_or_id – The name or ID of a BGPVPN.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `BGPVPN` or None

  get_bgpvpn(bgpvpn)

    Get a signle BGPVPN

    Parameters:

      bgpvpn – The value can be the ID of a BGPVPN or a `BgpVpn` instance.

    Returns:

      One `BgpVpn`

    Raises:

      `NotFoundException` when no resource can be found.

  update_bgpvpn(bgppvpn, **attrs)

    Update a BGPVPN

    Parameters:

      - bgpvpn – Either the ID of a BGPVPN or a `BgpVpn` instance.

      - attrs – The attributes to update on the BGPVPN represented by `value`.

    Returns:

      The updated BGPVPN

    Return type:

      `BgpVpn`

  bgpvpns(**query)

    Return a generator of BGP VPNs

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of BgpVPN objects

    Return type:

      `BgpVpn`

  create_bgpvpn_network_association(bgpvpn, **attrs)

    Create a new BGPVPN Network Association

    Parameters:

      - bgpvpn – The value can be either the ID of a bgpvpn or a `BgpVpn` instance.

      - attrs – Keyword arguments which will be used to create a `BgpVpnNetworkAssociation`, comprised of the properties on the BgpVpnNetworkAssociation class.

    Returns:

      The results of BgpVpnNetworkAssociation creation

    Return type:

      `BgpVpnNetworkAssociation`

  delete_bgpvpn_network_association(bgpvpn, net_association, ignore_missing=True)

    Delete a BGPVPN Network Association

    Parameters:

      - bgpvpn – The value can be either the ID of a bgpvpn or a `BgpVpn` instance.

      - net_association – The value can be either the ID of a bgpvpn_network_association or a `BgpVpnNetworkAssociation` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the BgpVpnNetworkAssociation does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent BgpVpnNetworkAssociation.

    Returns:

      `None`

  get_bgpvpn_network_association(bgpvpn, net_association)

    Get a signle BGPVPN Network Association

    Parameters:

      - bgpvpn – The value can be the ID of a BGPVPN or a `BgpVpn` instance.

      - net_association – The value can be the ID of a BgpVpnNetworkAssociation or a `BgpVpnNetworkAssociation` instance.

    Returns:

      One `BgpVpnNetworkAssociation`

    Raises:

      `NotFoundException` when no resource can be found.

  bgpvpn_network_associations(bgpvpn, **query)

    Return a generator of BGP VPN Network Associations

    Param:

      bgpvpn: The value can be the ID of a BGPVPN or a `BgpVpn` instance.

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of BgpVpnNetworkAssociation objects

    Return type:

      `BgpVpnNetworkAssociation`

  create_bgpvpn_port_association(bgpvpn, **attrs)

    Create a new BGPVPN Port Association

    Parameters:

      - bgpvpn – The value can be either the ID of a bgpvpn or a `BgpVpn` instance.

      - attrs – Keyword arguments which will be used to create a `BgpVpnPortAssociation`, comprised of the properties on the BgpVpnPortAssociation class.

    Returns:

      The results of BgpVpnPortAssociation creation

    Return type:

      `BgpVpnPortAssociation`

  delete_bgpvpn_port_association(bgpvpn, port_association, ignore_missing=True)

    Delete a BGPVPN Port Association

    Parameters:

      - bgpvpn – The value can be either the ID of a bgpvpn or a `BgpVpn` instance.

      - port_association – The value can be either the ID of a bgpvpn_port_association or a `BgpVpnPortAssociation` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the BgpVpnPortAssociation does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent BgpVpnPortAssociation.

    Returns:

      `None`

  find_bgpvpn_port_association(name_or_id, bgpvpn_id, ignore_missing=True, **query)

    Find a single BGPVPN Port Association

    Parameters:

      - name_or_id – The name or ID of a BgpVpnNetworkAssociation.

      - bgpvpn_id – The value can be the ID of a BGPVPN.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `BGPVPN` or None

  get_bgpvpn_port_association(bgpvpn, port_association)

    Get a signle BGPVPN Port Association

    Parameters:

      - bgpvpn – The value can be the ID of a BGPVPN or a `BgpVpn` instance.

      - port_association – The value can be the ID of a BgpVpnPortAssociation or a `BgpVpnPortAssociation` instance.

    Returns:

      One `BgpVpnPortAssociation`

    Raises:

      `NotFoundException` when no resource can be found.

  update_bgpvpn_port_association(bgpvpn, port_association, **attrs)

    Update a BPGPN Port Association

    Parameters:

      - bgpvpn – Either the ID of a BGPVPN or a `BgpVpn` instance.

      - port_association – The value can be the ID of a BgpVpnPortAssociation or a `BgpVpnPortAssociation` instance.

      - attrs – The attributes to update on the BGPVPN represented by `value`.

    Returns:

      The updated BgpVpnPortAssociation.

    Return type:

      `BgpVpn`

  bgpvpn_port_associations(bgpvpn, **query)

    Return a generator of BGP VPN Port Associations

    Param:

      bgpvpn: The value can be the ID of a BGPVPN or a `BgpVpn` instance.

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of BgpVpnNetworkAssociation objects

    Return type:

      `BgpVpnNetworkAssociation`

  create_bgpvpn_router_association(bgpvpn, **attrs)

    Create a new BGPVPN Router Association

    Parameters:

      - bgpvpn – The value can be either the ID of a bgpvpn or a `BgpVpn` instance.

      - attrs – Keyword arguments which will be used to create a `BgpVpnRouterAssociation`, comprised of the properties on the BgpVpnRouterAssociation class.

    Returns:

      The results of BgpVpnRouterAssociation creation

    Return type:

      `BgpVpnRouterAssociation`

  delete_bgpvpn_router_association(bgpvpn, router_association, ignore_missing=True)

    Delete a BGPVPN Router Association

    Parameters:

      - bgpvpn – The value can be either the ID of a bgpvpn or a `BgpVpn` instance.

      - port_association – The value can be either the ID of a bgpvpn_router_association or a `BgpVpnRouterAssociation` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the BgpVpnRouterAssociation does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent BgpVpnRouterAsociation.

    Returns:

      `None`

  get_bgpvpn_router_association(bgpvpn, router_association)

    Get a signle BGPVPN Router Association

    Parameters:

      - bgpvpn – The value can be the ID of a BGPVPN or a `BgpVpn` instance.

      - router_association – The value can be the ID of a BgpVpnRouterAssociation or a `BgpVpnRouterAssociation` instance.

    Returns:

      One `BgpVpnRouterAssociation`

    Raises:

      `NotFoundException` when no resource can be found.

  update_bgpvpn_router_association(bgpvpn, router_association, **attrs)

    Update a BPGPN Router Association

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of BgpVpnNetworkAssociation objects

    Return type:

      `BgpVpnNetworkAssociation`

  bgpvpn_router_associations(bgpvpn, **query)

    Return a generator of BGP VPN router Associations

    Param:

      bgpvpn: The value can be the ID of a BGPVPN or a `BgpVpn` instance.

    Parameters:

      query (dict) – Optional query parameters to be sent to limit the resources being returned.

    Returns:

      A generator of BgpVpnRouterAssociation objects

    Return type:

      `BgpVpnRouterAssociation`

### SFC operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_sfc_flow_classifier(**attrs)

    Create a new Flow Classifier from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `SfcFlowClassifier`, comprised of the properties on the SfcFlowClassifier class.

    Returns:

      The results of SFC Flow Classifier creation

    Return type:

      `SfcFlowClassifier`

  delete_sfc_flow_classifier(flow_classifier, ignore_missing=True)

    Delete a Flow Classifier

    Parameters:

      - flow_classifier – The value can be either the ID of a flow classifier or a `SfcFlowClassifier` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the flow classifier does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent flow classifier.

    Returns:

      `None`

  find_sfc_flow_classifier(name_or_id, ignore_missing=True, **query)

    Find a single Flow Classifier

    Parameters:

      - name_or_id (str) – The name or ID of an SFC flow classifier.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `SfcFlowClassifier` or None

  get_sfc_flow_classifier(flow_classifier)

    Get a single Flow Classifier

    Parameters:

      flow_classifier – The value can be the ID of an SFC flow classifier or a `SfcFlowClassifier` instance.

    Returns:

      `SfcFlowClassifier`

    Raises:

      `NotFoundException` when no resource can be found.

  update_sfc_flow_classifier(flow_classifier, **attrs)

    Update a Flow Classifier

    Parameters:

      - flow_classifier – The value can be the ID of a Flow Classifier `SfcFlowClassifier`, instance.

      - attrs – The attributes to update on the Flow Classifier

    Returns:

      The updated Flow Classifier.

    Return type:

      `SfcFlowClassifier`

  create_sfc_port_chain(**attrs)

    Create a new Port Chain from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `SfcPortChain`, comprised of the properties on the SfcPortchain class.

    Returns:

      The results of SFC Port Chain creation

    Return type:

      `SfcPortChain`

  delete_sfc_port_chain(port_chain, ignore_missing=True)

    Delete a Port Chain

    Parameters:

      - port_chain – The value can be either the ID of a port chain or a `SfcPortChain` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the port chain does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent port chain.

    Returns:

      `None`

  find_sfc_port_chain(name_or_id, ignore_missing=True, **query)

    Find a single Port Chain

    Parameters:

      - name_or_id (str) – The name or ID of an SFC port chain.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `SfcPortChain` or None

  get_sfc_port_chain(port_chain)

    Get a signle Port Chain

    Parameters:

      port_chain – The value can be the ID of an SFC port chain or a `SfcPortChain` instance.

    Returns:

      `SfcPortchain`

    Raises:

      `NotFoundException` when no resource can be found.

  update_sfc_port_chain(port_chain, **attrs)

    Update a Port Chain

    Parameters:

      - flow_classifier – The value can be the ID of a Flow Classifier `SfcFlowClassifier`, instance.

      - attrs – The attributes to update on the Flow Classifier

    Returns:

      The updated Flow Classifier.

    Return type:

      `SfcFlowClassifier`

  create_sfc_port_pair(**attrs)

    Create a new Port Pair from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `SfcPortPair`, comprised of the properties on the SfcPortPair class.

    Returns:

      The results of SFC Port Pair creation

    Return type:

      `SfPortPair`

  delete_sfc_port_pair(port_pair, ignore_missing=True)

    Delete a Port Pair

    Parameters:

      - port_pair – The value can be either the ID of a port pair or a `SfcPortPair` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the port pair does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent port pair.

    Returns:

      `None`

  find_sfc_port_pair(name_or_id, ignore_missing=True, **query)

    Find a single Port Pair

    Parameters:

      - name_or_id (str) – The name or ID of an SFC port pair.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `SfcPortPair` or None

  get_sfc_port_pair(port_pair)

    Get a signle Port Pair

    Parameters:

      port_pair – The value can be the ID of an SFC port pair or a `SfcPortPair` instance.

    Returns:

      `SfcPortPair`

    Raises:

      `NotFoundException` when no resource can be found.

  update_sfc_port_pair(port_pair, **attrs)

    Update a Port Pair

    Parameters:

      - port_pair – The value can be the ID of a Port Pair `SfcPortPair`, instance.

      - attrs – The attributes to update on the Port Pair

    Returns:

      The updated Port Pair.

    Return type:

      `SfcPortPair`

  create_sfc_port_pair_group(**attrs)

    Create a new Port Pair Group from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `SfcPortPairGroup`, comprised of the properties on the SfcPortPairGroup class.

    Returns:

      The results of SFC Port Pair Group creation

    Return type:

      `SfcPortPairGroup`

  delete_sfc_port_pair_group(port_pair_group, ignore_missing=True)

    Delete a Port Pair Group

    Parameters:

      - port_pair_group – The value can be either the ID of a port pair group or a `SfcPortPairGroup` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the port pair group does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent port pair group.

    Returns:

      `None`

  find_sfc_port_pair_group(name_or_id, ignore_missing=True, **query)

    Find a single Port Pair Group

    Parameters:

      - name_or_id (str) – The name or ID of an SFC port pair group.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `SfcPortPairGroup` or None

  get_sfc_port_pair_group(port_pair_group)

    Get a signle Port Pair Group

    Parameters:

      port_pair_group – The value can be the ID of an SFC port pair group or a `SfcPortPairGroup` instance.

    Returns:

      `SfcPortPairGroup`

    Raises:

      `NotFoundException` when no resource can be found.

  update_sfc_port_pair_group(port_pair_group, **attrs)

    Update a Port Pair Group

    Parameters:

      - port_pair_group – The value can be the ID of a Port Pair Group `SfcPortPairGroup`, instance.

      - attrs – The attributes to update on the Port Pair Group

    Returns:

      The updated Port Pair Group.

    Return type:

      `SfcPortPairGroup`

  create_sfc_service_graph(**attrs)

    Create a new Service Graph from attributes

    Parameters:

      attrs – Keyword arguments which will be used to create a `SfcServiceGraph`, comprised of the properties on the SfcServiceGraph class.

    Returns:

      The results of SFC Service Graph creation

    Return type:

      `SfcServiceGraph`

  delete_sfc_service_graph(service_graph, ignore_missing=True)

    Delete a Service Graph

    Parameters:

      - service_graph – The value can be either the ID of a service graph or a `SfcServiceGraph` instance.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the service graph does not exist. When set to `True`, no exception will be set when attempting to delete a nonexistent service graph.

    Returns:

      `None`

  find_sfc_service_graph(name_or_id, ignore_missing=True, **query)

    Find a single Service Graph

    Parameters:

      - name_or_id (str) – The name or ID of an SFC service graph.

      - ignore_missing (bool) – When set to `False` `NotFoundException` will be raised when the resource does not exist. When set to `True`, None will be returned when attempting to find a nonexistent resource.

      - query (dict) – Any additional parameters to be passed into underlying methods. such as query filters.

    Returns:

      One `SfcServiceGraph` or None

  get_sfc_service_graph(service_graph)

    Get a signle Service Graph

    Parameters:

      service_graph – The value can be the ID of an SFC service graph or a `SfcServiceGraph` instance.

    Returns:

      `SfcServiceGraph`

    Raises:

      `NotFoundException` when no resource can be found.

  update_sfc_service_graph(service_graph, **attrs)

    Update a Service Graph

    Parameters:

      - service_graph – The value can be the ID of a Service Graph `SfcServiceGraph`, instance.

      - attrs – The attributes to update on the Service Graph

    Returns:

      The updated Service Graph.

    Return type:

      `SfcServiceGraph`

### Tap Mirror operations

class openstack.network.v2._proxy.Proxy(session, *, service_type=None, service_name=None, interface=None, region_name=None, endpoint_override=None, version=None, auth=None, user_agent=None, connect_retries=None, logger=None, allow=None, additional_headers=None, client_name=None, client_version=None, allow_version_hack=None, global_request_id=None, min_version=None, max_version=None, default_microversion=None, status_code_retries=None, retriable_status_codes=None, raise_exc=None, rate_limit=None, concurrency=None, connect_retry_delay=None, status_code_retry_delay=None, statsd_client=None, statsd_prefix=None, prometheus_counter=None, prometheus_histogram=None, influxdb_config=None, influxdb_client=None)
  create_tap_mirror(**attrs)

    Create a new Tap Mirror from attributes

  delete_tap_mirror(tap_mirror, ignore_missing=True)

    Delete a Tap Mirror

  find_tap_mirror(name_or_id, ignore_missing=True, **query)

    Find a single Tap Mirror

  get_tap_mirror(tap_mirror)

    Get a signle Tap Mirror

  update_tap_mirror(tap_mirror, **attrs)

    Update a Tap Mirror

  tap_mirrors(**query)

    Return a generator of Tap Mirrors

this page last updated: 2026-01-16 23:06:19

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.